// Generated by gencpp from file panda_qp_control/PandaRunMsg.msg
// DO NOT EDIT!


#ifndef PANDA_QP_CONTROL_MESSAGE_PANDARUNMSG_H
#define PANDA_QP_CONTROL_MESSAGE_PANDARUNMSG_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <geometry_msgs/Twist.h>

namespace panda_qp_control
{
template <class ContainerAllocator>
struct PandaRunMsg_
{
  typedef PandaRunMsg_<ContainerAllocator> Type;

  PandaRunMsg_()
    : header()
    , X_err()  {
    }
  PandaRunMsg_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , X_err(_alloc)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef  ::geometry_msgs::Twist_<ContainerAllocator>  _X_err_type;
  _X_err_type X_err;





  typedef boost::shared_ptr< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> const> ConstPtr;

}; // struct PandaRunMsg_

typedef ::panda_qp_control::PandaRunMsg_<std::allocator<void> > PandaRunMsg;

typedef boost::shared_ptr< ::panda_qp_control::PandaRunMsg > PandaRunMsgPtr;
typedef boost::shared_ptr< ::panda_qp_control::PandaRunMsg const> PandaRunMsgConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::panda_qp_control::PandaRunMsg_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::panda_qp_control::PandaRunMsg_<ContainerAllocator1> & lhs, const ::panda_qp_control::PandaRunMsg_<ContainerAllocator2> & rhs)
{
  return lhs.header == rhs.header &&
    lhs.X_err == rhs.X_err;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::panda_qp_control::PandaRunMsg_<ContainerAllocator1> & lhs, const ::panda_qp_control::PandaRunMsg_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace panda_qp_control

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
{
  static const char* value()
  {
    return "8d02e4fbb1497f25981026af4efe65e3";
  }

  static const char* value(const ::panda_qp_control::PandaRunMsg_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x8d02e4fbb1497f25ULL;
  static const uint64_t static_value2 = 0x981026af4efe65e3ULL;
};

template<class ContainerAllocator>
struct DataType< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
{
  static const char* value()
  {
    return "panda_qp_control/PandaRunMsg";
  }

  static const char* value(const ::panda_qp_control::PandaRunMsg_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n"
"geometry_msgs/Twist X_err\n"
"\n"
"================================================================================\n"
"MSG: std_msgs/Header\n"
"# Standard metadata for higher-level stamped data types.\n"
"# This is generally used to communicate timestamped data \n"
"# in a particular coordinate frame.\n"
"# \n"
"# sequence ID: consecutively increasing ID \n"
"uint32 seq\n"
"#Two-integer timestamp that is expressed as:\n"
"# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n"
"# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n"
"# time-handling sugar is provided by the client library\n"
"time stamp\n"
"#Frame this data is associated with\n"
"string frame_id\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Twist\n"
"# This expresses velocity in free space broken into its linear and angular parts.\n"
"Vector3  linear\n"
"Vector3  angular\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Vector3\n"
"# This represents a vector in free space. \n"
"# It is only meant to represent a direction. Therefore, it does not\n"
"# make sense to apply a translation to it (e.g., when applying a \n"
"# generic rigid transformation to a Vector3, tf2 will only apply the\n"
"# rotation). If you want your data to be translatable too, use the\n"
"# geometry_msgs/Point message instead.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
;
  }

  static const char* value(const ::panda_qp_control::PandaRunMsg_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.X_err);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct PandaRunMsg_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::panda_qp_control::PandaRunMsg_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::panda_qp_control::PandaRunMsg_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "X_err: ";
    s << std::endl;
    Printer< ::geometry_msgs::Twist_<ContainerAllocator> >::stream(s, indent + "  ", v.X_err);
  }
};

} // namespace message_operations
} // namespace ros

#endif // PANDA_QP_CONTROL_MESSAGE_PANDARUNMSG_H
